library angular2.src.core.annotations.annotations;
import 'package:angular2/src/facade/lang.dart' show ABSTRACT, CONST, normalizeBlank;
import 'package:angular2/src/facade/collection.dart' show List;
import './template_config.dart' show TemplateConfig;
@ABSTRACT() 
class Directive {
final dynamic selector;
final dynamic bind;
final dynamic lightDomServices;
final dynamic implementsTypes;
final dynamic lifecycle;
@CONST() 
const Directive({selector,
  bind,
  lightDomServices,
  implementsTypes,
  lifecycle}): selector = selector, lightDomServices = lightDomServices, implementsTypes = implementsTypes, bind = bind, lifecycle = lifecycle;
}
class Component extends Directive {
final dynamic template;
final dynamic lightDomServices;
final dynamic shadowDomServices;
final dynamic componentServices;
final dynamic lifecycle;
@CONST() 
const Component({selector,
  bind,
  template,
  lightDomServices,
  shadowDomServices,
  componentServices,
  implementsTypes,
  lifecycle}): template = template, lightDomServices = lightDomServices, shadowDomServices = shadowDomServices, componentServices = componentServices, lifecycle = lifecycle, super(selector: selector, bind: bind, lightDomServices: lightDomServices, implementsTypes: implementsTypes, lifecycle: lifecycle);
}
class Decorator extends Directive {
final bool compileChildren;
@CONST() 
const Decorator({selector,
  bind,
  lightDomServices,
  implementsTypes,
  lifecycle,
  compileChildren : true}): compileChildren = compileChildren, super(selector: selector, bind: bind, lightDomServices: lightDomServices, implementsTypes: implementsTypes, lifecycle: lifecycle);
}
class Template extends Directive {
@CONST() 
const Template({selector,
  bind,
  lightDomServices,
  implementsTypes,
  lifecycle}): super(selector: selector, bind: bind, lightDomServices: lightDomServices, implementsTypes: implementsTypes, lifecycle: lifecycle);
}
var onDestroy = "onDestroy";
