library angular2.src.core.compiler.directive_metadata_reader;
import 'package:angular2/src/facade/lang.dart' show Type, isPresent, BaseException, stringify;
import 'package:angular2/src/facade/collection.dart' show List, ListWrapper;
import '../annotations/annotations.dart' show Directive, Component;
import './directive_metadata.dart' show DirectiveMetadata;
import 'package:angular2/src/reflection/reflection.dart' show reflector;
import './shadow_dom_strategy.dart' show ShadowDom, ShadowDomStrategy, ShadowDomNative;
class DirectiveMetadataReader {
DirectiveMetadata read(Type type) {
  var annotations = reflector.annotations(type);
  if (isPresent(annotations)) {
    for (var i = 0; i < annotations.length; i++) {
      var annotation = annotations[i];
      if (annotation is Component) {
        return new DirectiveMetadata(type, annotation, this.componentDirectivesMetadata(annotation));
      }
      if (annotation is Directive) {
        return new DirectiveMetadata(type, annotation, null);
      }
    }
  }
  throw new BaseException('''No Directive annotation found on ${stringify(type)}''');
}
List componentDirectivesMetadata(Component annotation) {
  var template = annotation.template;
  return isPresent(template) && isPresent(template.directives) ? template.directives : [];
}
}
