library angular2.src.core.life_cycle.life_cycle;
import 'package:angular2/src/facade/lang.dart' show FIELD, print;
import 'package:angular2/change_detection.dart' show ChangeDetector;
import 'package:angular2/src/core/zone/vm_turn_zone.dart' show VmTurnZone;
import 'package:angular2/src/facade/collection.dart' show ListWrapper;
class LifeCycle {
ChangeDetector _changeDetector;
bool _enforceNoNewChanges;
LifeCycle(ChangeDetector changeDetector, [bool enforceNoNewChanges = false]) {
  this._changeDetector = changeDetector;
  this._enforceNoNewChanges = enforceNoNewChanges;
}
registerWith(VmTurnZone zone) {
  var errorHandler = (exception, stackTrace) {
    var longStackTrace = ListWrapper.join(stackTrace, "\n\n-----async gap-----\n");
    print('''${exception}\n\n${longStackTrace}''');
    throw exception;
  };
  zone.initCallbacks(onErrorHandler: errorHandler, onTurnDone: () => this.tick());
}
tick() {
  this._changeDetector.detectChanges();
  if (this._enforceNoNewChanges) {
    this._changeDetector.checkNoChanges();
  }
}
}
