library angular2.src.directives.ng_if;
import 'package:angular2/src/core/annotations/annotations.dart' show Template;
import 'package:angular2/src/core/compiler/viewport.dart' show ViewPort;
import 'package:angular2/src/facade/lang.dart' show isBlank;
@Template(selector: '[ng-if]', bind: const{'ng-if': 'condition'}) 
class NgIf {
ViewPort viewPort;
bool prevCondition;
NgIf(ViewPort viewPort) {
  this.viewPort = viewPort;
  this.prevCondition = null;
}
set condition(newCondition) {
  if (newCondition && (isBlank(this.prevCondition) || !this.prevCondition)) {
    this.prevCondition = true;
    this.viewPort.create();
  } else if (!newCondition && (isBlank(this.prevCondition) || this.prevCondition)) {
    this.prevCondition = false;
    this.viewPort.clear();
  }
}
}
