library angular2.src.forms.decorators;
import 'package:angular2/core.dart' show Decorator, NgElement, Ancestor;
import 'package:angular2/src/facade/dom.dart' show DOM;
import 'package:angular2/src/facade/lang.dart' show isPresent;
import 'package:angular2/src/facade/collection.dart' show ListWrapper;
import './model.dart' show ControlGroup, Control;
@Decorator(selector: '[control-name]', bind: const{'control-name': 'controlName'}) 
class ControlDecorator {
ControlGroupDecorator _groupDecorator;
NgElement _el;
String _controlName;
ControlDecorator(@Ancestor() ControlGroupDecorator groupDecorator, NgElement el) {
  this._groupDecorator = groupDecorator;
  groupDecorator.addControlDecorator(this);
  this._el = el;
  DOM.on(el.domElement, "change", (_) {
    return this._updateControl();
  });
}
set controlName(String name) {
  this._controlName = name;
  this._updateDOM();
}
_updateDOM() {
  if (isPresent(this._controlName)) {
    dynamic inputElem = this._el.domElement;
    inputElem.value = this._control().value;
  }
}
_updateControl() {
  dynamic inputElem = this._el.domElement;
  this._control().value = inputElem.value;
}
_control() {
  return this._groupDecorator.findControl(this._controlName);
}
}
@Decorator(selector: '[control-group]', bind: const{'control-group': 'controlGroup'}) 
class ControlGroupDecorator {
ControlGroup _controlGroup;
List _controlDecorators;
ControlGroupDecorator() {
  this._controlDecorators = ListWrapper.create();
}
set controlGroup(ControlGroup controlGroup) {
  this._controlGroup = controlGroup;
  ListWrapper.forEach(this._controlDecorators, (cd) {
    return cd._updateDOM();
  });
}
addControlDecorator(ControlDecorator c) {
  ListWrapper.push(this._controlDecorators, c);
}
Control findControl(String name) {
  return this._controlGroup.controls[name];
}
}
